IMPLEMENTATION MODULE Debug;
(* $L+ *)
FROM SYSTEM IMPORT ASSEMBLER,ADDRESS,SEG,OFS;
FROM ScreenLo IMPORT PrintString,PrintCard;
IMPORT System;

PROCEDURE WaitKey;
  BEGIN
    ASM
    Clean:
       MOV AH,1
       INT 16H
       JNZ Clean
       MOV  AH,0
       INT 16H
     END;
   END WaitKey;

PROCEDURE PrintAddress(XPos,YPos,Attr:CARDINAL; A:ADDRESS);
  VAR HexLine:ARRAY[0..8] OF CHAR; Lauf:CARDINAL;

  PROCEDURE HexDigit(HexZahl,Num:CARDINAL):CHAR;
    VAR Ch:CHAR;
    BEGIN
      ASM
        MOV AX,HexZahl
        MOV CX,Num
        DEC CX
        ADD CX,CX
        ADD CX,CX
        SHR AX,CL
        AND AX,000FH
        ADD AL,'0'
        CMP AL,'9'
        JLE Gut
        ADD AL,7
      Gut:
        MOV Ch,AL
      END;
      RETURN Ch;
    END HexDigit;

  BEGIN
    HexLine:='';
    FOR Lauf := 0 TO 3 DO
      HexLine[Lauf]:=HexDigit(A.SEG,4-Lauf);
    END;
    HexLine[4]:=':';
    FOR Lauf := 5 TO 8 DO
      HexLine[Lauf]:=HexDigit(A.OFS,9-Lauf);
    END;
    PrintString(XPos,YPos,Attr,HexLine);
  END PrintAddress;

PROCEDURE MyErr(ErrNum:CARDINAL; ErrAddr:ADDRESS);
  VAR
    Mess1:ARRAY[0..9] OF CHAR;
    Mess2:ARRAY[0..9]OF CHAR;
  BEGIN
    Mess1:='FehlerNr: ';
    Mess2:='Adresse:  ';
    PrintString(1,1,112,Mess1);
    PrintCard(10,1,112,ErrNum,3);
    PrintString(1,2,112,Mess2);
    PrintAddress(10,2,112,ErrAddr);
    WaitKey;
  END MyErr;  


BEGIN
  System.InstallRTErrorHandler(MyErr);
END Debug.