IMPLEMENTATION MODULE Pointers;
(* Jrg Hopfe 11/89 FST Modula-2 v2.0 *)

FROM SYSTEM IMPORT ADDRESS,ASSEMBLER,OFS,SEG;

PROCEDURE PtrINC(VAR Ptr:ADDRESS; Count:CARDINAL);
  BEGIN
    ASM
      LES DI,[Ptr]
      MOV AX,[Count]
      ADD ES:[DI],AX
    END;
  END PtrINC;

PROCEDURE PtrDEC(VAR Ptr:ADDRESS; Count:CARDINAL);
  BEGIN
    ASM
      LES DI,[Ptr]
      MOV AX,[Count]
      SUB ES:[DI],AX
    END;
  END PtrDEC;

PROCEDURE PtrNormalise(VAR Ptr:ADDRESS);
  BEGIN
    ASM
      MOV AX,WORD Ptr       (* OFS anteil von Ptr nach AX *)
      MOV BX,WORD Ptr+2     (* Seg Anteil nach BX *)

   NextNormal:
      CMP AX,16             (* AX > 16 ? = 1 Paragraph *)
      JLE Out               (* Nein => Fertig *)

      SUB AX,16             (* Ofs=Ofs-16 *)
      INC BX                (* Seg+1 *)
      JMP NextNormal        (* Nchste Runde *)

    Out:
      MOV WORD Ptr+2,BX     (* SEG-Anteil wieder in VAR *)
      MOV WORD Ptr,AX       (* Dito verbleibenden OFS-Anteil *)
    END;
  END PtrNormalise;

PROCEDURE PtrCompare(Ptr1,Ptr2:ADDRESS):INTEGER;
  BEGIN
    PtrNormalise(Ptr1);
    PtrNormalise(Ptr2);
    IF Ptr1.SEG=Ptr2.SEG THEN
      IF Ptr1.OFS=Ptr2.OFS THEN
        RETURN 0;
      ELSIF Ptr1.OFS > Ptr2.OFS THEN
        RETURN 1;
      ELSE
        RETURN -1;
      END;
    ELSIF Ptr1.SEG > Ptr2.SEG THEN
      RETURN 1;
    ELSE
      RETURN -1;
    END;
  END PtrCompare;

PROCEDURE PtrDiff(Ptr1,Ptr2:ADDRESS):LONGCARD;
  VAR Erg:LONGCARD;
  BEGIN
    ASM
      XOR DX,DX
      MOV AX,WORD Ptr2
      
      MOV CL,4
      SHL AX,1
      RCL DX,1
      SUB AX,WORD Ptr1 (* Offset Ptr2-Offset Ptr1 *)
      MOV DX,WORD Ptr2+2
      SBB DX,WORD Ptr1+2 (* Segment Ptr2 - Segment Ptr1 - Carry *)
      MOV Erg,AX
      MOV Erg+2,DX
    END;
    RETURN Erg;
  END PtrDiff;


END Pointers.