MODULE TXORGraph;

IMPORT XORGraph, IO;
FROM Graph    IMPORT InitHerc, InitVGA, InitEGA, InitCGA,
                     Width, Depth, NumColor,
                     GraphMode, TextMode, Line, HLine, Disc, Ellipse;

VAR c : CHAR;
    i, col  : CARDINAL;

PROCEDURE ChooseCard;
VAR card : CHAR;
BEGIN
  IO.WrStr ('Give Number of Your Graphic Card:'); IO.WrLn; IO.WrLn;
  REPEAT
    IO.WrStr ('1 : Hercules'); IO.WrLn;
    IO.WrStr ('2 : CGA'); IO.WrLn;
    IO.WrStr ('3 : EGA'); IO.WrLn;
    IO.WrStr ('4 : VGA'); IO.WrLn;
    IO.WrStr ('5 : Unknown'); IO.WrLn;
    card := IO.RdKey();
  UNTIL (card >= '1') AND (card <= '5');
    CASE card OF
      | '1' : InitHerc; col := 1;
      | '2' : InitCGA; col := 2;
      | '3' : InitEGA; col := 3;
      | '4' : InitVGA; col := 11;
      | '5' : IO.WrLn; IO.WrStr ('O.K., I see, I worked for nothing');
              HALT;
    END;
END ChooseCard;

PROCEDURE PlotTest ();
BEGIN
  FOR i := 9 TO Width-11 BY 10 DO
    Line (i, 9, i, Depth-11, col);
  END;
  FOR i := 9 TO Depth-11 BY 10 DO
    HLine (9, i, Width-11, col);
  END;
  Disc (Width DIV 2, Depth DIV 3, Depth DIV 4, col);
  Ellipse (Width DIV 4, Depth DIV 2, Width DIV 5, Depth DIV 3, 5, TRUE);
  Ellipse (2*Width DIV 3, Depth DIV 2, Width DIV 3, Depth DIV 5, 5, TRUE);
END PlotTest;

BEGIN
  ChooseCard;

  IO.WrLn; IO.WrStr ('You will see:');
  IO.WrLn; IO.WrStr ('1. Normal Mode');
  IO.WrLn; IO.WrStr ('2. XOR Mode');
  IO.WrLn; IO.WrLn;
  IO.WrStr ('(Press any active key [e.g. not <SHIFT>] to continue...)');
  c := IO.RdKey();

  GraphMode;
  PlotTest ();
  c := IO.RdKey();

  (* Clear Screen *)
  FOR i := 0 TO Depth-1 DO
    HLine ( 0, i, Width-1, 0);
  END;

  XORGraph.SetMode (XORGraph.XOR);
  PlotTest ();
  c := IO.RdKey();

  TextMode;

END TXORGraph.